Subject: [MIB-DOCTORS] smilint: notifcation x is not reverse mappable" (draft-ietf-softwire-dslite-mib compilation)

From: Benoit Claise <[email-masked]>
Date: Thu, 17 Dec 2015 11:27:06 +0100

Dear all,

Compiling https://www.ietf.org/id/draft-ietf-softwire-dslite-mib-13.txt, 
I have

Your request has been processed by the command

timeout 10 smilint -s -e -l 6 -p mibs/NATV2-MIB mibs/DSLite-MIB 2>report.txt

You can access any intermediately created files, the processing report 
(which might be empty if no errors or warnings have been found), and 
output files (in case of a conversion request) for reading and download 
from a temporary server directory 
<http://www.ibr.cs.tu-bs.de/projects/libsmi/tools/tmp/l73PRn/> for 
approx. 24 hours.

While processing your request the following errors and/or warnings have 
been found:

mibs/NATV2-MIB:368: warning: identifier `natv2SubscriberIndex' differs from `Natv2SubscriberIndex' only in case
mibs/NATV2-MIB:109: info: previous definition of `Natv2SubscriberIndex'
mibs/NATV2-MIB:805: warning: identifier `natv2InstanceIndex' differs from `Natv2InstanceIndex' only in case
mibs/NATV2-MIB:135: info: previous definition of `Natv2InstanceIndex'
mibs/NATV2-MIB:1689: warning: identifier `natv2PoolIndex' differs from `Natv2PoolIndex' only in case
mibs/NATV2-MIB:153: info: previous definition of `Natv2PoolIndex'
mibs/NATV2-MIB:2074: warning: `InetAddress' object should have an accompanied preceding `InetAddressType' object
mibs/NATV2-MIB:2087: warning: `InetAddress' object should have an accompanied preceding `InetAddressType' object
mibs/DSLite-MIB:72: [2] {object-identifier-not-prefix} Object identifier element `xxx' name only allowed as first element
mibs/DSLite-MIB:29: [2] {module-identity-registration} illegal module identity registration
mibs/DSLite-MIB:118: [5] {index-exceeds-too-large} warning: index of row `dsliteTunnelEntry' can exceed OID size limit by 392 subidentifier(s)
mibs/DSLite-MIB:198: [5] {index-exceeds-too-large} warning: index of row `dsliteNATBindEntry' can exceed OID size limit by 189 subidentifier(s)
mibs/DSLite-MIB:681: [5] {notification-not-reversible} warning: notification `dsliteTunnelNumAlarm' is not reverse mappable
mibs/DSLite-MIB:692: [5] {notification-not-reversible} warning: notification `dsliteAFTRUserSessionNumAlarm' is not reverse mappable
mibs/DSLite-MIB:712: [5] {notification-not-reversible} warning: notification `dsliteAFTRPortUsageOfSpecificIpAlarm' is not reverse mappable
mibs/DSLite-MIB:5: [5] {import-unused} warning: identifier `Gauge32' imported from module `SNMPv2-SMI' is never used
mibs/DSLite-MIB:5: [5] {import-unused} warning: identifier `TimeTicks' imported from module `SNMPv2-SMI' is never used
mibs/DSLite-MIB:13: [5] {import-unused} warning: identifier `DisplayString' imported from module `SNMPv2-TC' is never used

Not sure what "is not reverse mappable" means. L5 warnings, how 
important is this?
Any help appreciated.

Regards, Benoit

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Thu, 17 Dec 2015 12:55:38 +0100

On Thu, Dec 17, 2015 at 11:27:06AM +0100, Benoit Claise wrote:

[...]
 
> Not sure what "is not reverse mappable" means. L5 warnings, how 

SNMPv1 identifies notifications in a different way that SNMPv2c/SNMPv3
does and SMIv2 notification definitions are reverse mappable if they
are registered OID.0.X and smilint generates this warning if they are
not. This is the reason why the generally suggestion MIB OID layout
has a notifications branch registered with the subidentifier 0.

The MIB module in question has

dsliteNotifications  OBJECT IDENTIFIER
         ::=  { dsliteMIB 0 }

dsliteTraps  OBJECT IDENTIFIER
            ::=  { dsliteNotifications 1  }

and the notification registered below dsliteTraps. I do not think this
serves any purpose - if authors would simply follow RFC 4181 appendix
D the problem would not show up. (And in general, we talk about
notifications not traps in SMIv2.)

See also section 4.7 of RFC 4181.

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>

---

From: Benoit Claise <[email-masked]>
Date: Thu, 17 Dec 2015 15:00:28 +0100

Many thanks Jürgen.

Regards, Benoit